package org.ow2.bonita;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;

import org.ow2.bonita.activity.implementationNo.ImplNoAutoTest;
import org.ow2.bonita.activity.implementationNo.ImplNoManuTest;
import org.ow2.bonita.activity.route.CancelJoinXorTest;
import org.ow2.bonita.activity.route.InitialEndingNodeTest;
import org.ow2.bonita.activity.route.JoinAndTest;
import org.ow2.bonita.activity.route.JoinNoTest;
import org.ow2.bonita.activity.route.JoinSplitTest;
import org.ow2.bonita.activity.route.JoinXorTest;
import org.ow2.bonita.activity.route.SplitAndTest;
import org.ow2.bonita.transition.TransitionWithActivityVarTest;
import org.ow2.bonita.transition.TransitionWithWFProcessVarTest;
import org.ow2.bonita.variable.ActivityVariableTest;
import org.ow2.bonita.variable.ActivityVariableWithSplitJoinTest;
import org.ow2.bonita.variable.ProcessVariableTest;
import org.ow2.bonita.variable.VariableBasicTypeTest;

public final class UnitTests extends TestCase {
  /**
   * private constructor.
   */
  private UnitTests() {
  }

  /**
   * TestSuite.
   *
   * @return suite
   */
  public static Test suite() {
    final TestSuite suite = new TestSuite(UnitTests.class.getName());
    // $JUnit-BEGIN$
    //route
    suite.addTestSuite(SplitAndTest.class);
    suite.addTestSuite(JoinAndTest.class);
    suite.addTestSuite(JoinXorTest.class);
    suite.addTestSuite(JoinNoTest.class);
    suite.addTestSuite(JoinSplitTest.class);
    suite.addTestSuite(InitialEndingNodeTest.class);
    suite.addTestSuite(CancelJoinXorTest.class);
    //Implementation No
    suite.addTestSuite(ImplNoAutoTest.class);
    suite.addTestSuite(ImplNoManuTest.class);
    //Variable
    suite.addTestSuite(ProcessVariableTest.class);
    suite.addTestSuite(ActivityVariableTest.class);
    suite.addTestSuite(ActivityVariableWithSplitJoinTest.class);
    suite.addTestSuite(VariableBasicTypeTest.class);
    //participant
    //suite.addTestSuite(DbParticipantTest.class);
    //transition
    suite.addTestSuite(TransitionWithActivityVarTest.class);
    suite.addTestSuite(TransitionWithWFProcessVarTest.class);

    return suite;
  }


}
