package org.ow2.bonita.activity.implementationNo;

import java.net.URL;

import org.ow2.bonita.APITestCase;
import org.ow2.bonita.facade.def.majorElement.ProcessDefinition;
import org.ow2.bonita.facade.uuid.PackageDefinitionUUID;
import org.ow2.bonita.facade.uuid.ProcessDefinitionUUID;
import org.ow2.bonita.facade.uuid.ProcessInstanceUUID;
import org.ow2.bonita.util.BonitaException;

public class ImplNoAutoTest extends APITestCase {
  public void testImplNoAuto0JoinSplit() throws BonitaException {
    URL xpdlUrl = this.getClass().getResource("implNoAuto0JoinSplit.xpdl");
    String processId = "implNoAuto0JoinSplit";
    ProcessDefinition process = getManagementAPI().deployBar(getBarContent(xpdlUrl)).get(processId);
    PackageDefinitionUUID packageUUID = process.getPackageDefinitionUUID();
    ProcessDefinitionUUID processUUID = process.getUUID();
    ProcessInstanceUUID instanceUUID = getRuntimeAPI().instantiateProcess(processUUID);
    checkExecutedOnce(instanceUUID, new String[]{"act1"});
    getManagementAPI().undeploy(packageUUID);
    getRuntimeAPI().deleteProcessInstance(instanceUUID);
    getManagementAPI().deletePackage(packageUUID);
  }

  public void testImplNoAutoJoinSplit() throws BonitaException {
    URL xpdlUrl = this.getClass().getResource("implNoAutoJoinSplit.xpdl");
    String processId = "implNoAutoJoinSplit";
    ProcessDefinition process = getManagementAPI().deployBar(getBarContent(xpdlUrl)).get(processId);
    PackageDefinitionUUID packageUUID = process.getPackageDefinitionUUID();
    ProcessDefinitionUUID processUUID = process.getUUID();
    ProcessInstanceUUID instanceUUID = getRuntimeAPI().instantiateProcess(processUUID);
    checkExecutedOnce(instanceUUID, new String[]{"act1"});
    getManagementAPI().undeploy(packageUUID);
    getRuntimeAPI().deleteProcessInstance(instanceUUID);
    getManagementAPI().deletePackage(packageUUID);
  }

  public void testImplNoAutoSplit() throws BonitaException {
    URL xpdlUrl = this.getClass().getResource("implNoAutoSplit.xpdl");
    String processId = "implNoAutoSplit";
    ProcessDefinition process = getManagementAPI().deployBar(getBarContent(xpdlUrl)).get(processId);
    PackageDefinitionUUID packageUUID = process.getPackageDefinitionUUID();
    ProcessDefinitionUUID processUUID = process.getUUID();
    ProcessInstanceUUID instanceUUID = getRuntimeAPI().instantiateProcess(processUUID);
    checkExecutedOnce(instanceUUID, new String[]{"act1"});
    getManagementAPI().undeploy(packageUUID);
    getRuntimeAPI().deleteProcessInstance(instanceUUID);
    getManagementAPI().deletePackage(packageUUID);
  }

  public void testImplNoAutoJoin() throws BonitaException {
    URL xpdlUrl = this.getClass().getResource("implNoAutoJoin.xpdl");
    String processId = "implNoAutoJoin";
    ProcessDefinition process = getManagementAPI().deployBar(getBarContent(xpdlUrl)).get(processId);
    PackageDefinitionUUID packageUUID = process.getPackageDefinitionUUID();
    ProcessDefinitionUUID processUUID = process.getUUID();
    ProcessInstanceUUID instanceUUID = getRuntimeAPI().instantiateProcess(processUUID);
    checkExecutedOnce(instanceUUID, new String[]{"act1"});
    getManagementAPI().undeploy(packageUUID);
    getRuntimeAPI().deleteProcessInstance(instanceUUID);
    getManagementAPI().deletePackage(packageUUID);
  }

}
