package org.ow2.bonita.activity.implementationNo;

import java.net.URL;

import org.ow2.bonita.APITestCase;
import org.ow2.bonita.facade.def.majorElement.ProcessDefinition;
import org.ow2.bonita.facade.uuid.PackageDefinitionUUID;
import org.ow2.bonita.facade.uuid.ProcessDefinitionUUID;
import org.ow2.bonita.facade.uuid.ProcessInstanceUUID;
import org.ow2.bonita.util.BonitaException;

public class ImplNoManuTest extends APITestCase {
  public void testImplNoManu0JoinSplit() throws BonitaException {
    URL xpdlUrl = this.getClass().getResource("implNoManu0JoinSplit.xpdl");
    String processId = "implNoManu0JoinSplit";
    ProcessDefinition process = getManagementAPI().deployBar(getBarContent(xpdlUrl)).get(processId);
    PackageDefinitionUUID packageUUID = process.getPackageDefinitionUUID();
    ProcessDefinitionUUID processUUID = process.getUUID();
    ProcessInstanceUUID instanceUUID = getRuntimeAPI().instantiateProcess(processUUID);

    checkStopped(instanceUUID, new String[]{});
    // start & terminate "act1" task
    executeTask(instanceUUID, "act1");
    checkExecutedOnce(instanceUUID, new String[]{"act1"});
    getManagementAPI().undeploy(packageUUID);
    getRuntimeAPI().deleteProcessInstance(instanceUUID);
    getManagementAPI().deletePackage(packageUUID);
  }

  public void testImplNoManuJoinSplit() throws BonitaException {
    URL xpdlUrl = this.getClass().getResource("implNoManuJoinSplit.xpdl");
    String processId = "implNoManuJoinSplit";
    ProcessDefinition process = getManagementAPI().deployBar(getBarContent(xpdlUrl)).get(processId);
    PackageDefinitionUUID packageUUID = process.getPackageDefinitionUUID();
    ProcessDefinitionUUID processUUID = process.getUUID();
    ProcessInstanceUUID instanceUUID = getRuntimeAPI().instantiateProcess(processUUID);

    checkStopped(instanceUUID, new String[]{});
    // start & terminate "act1" task
    executeTask(instanceUUID, "act1");
    checkExecutedOnce(instanceUUID, new String[]{"act1"});
    getManagementAPI().undeploy(packageUUID);
    getRuntimeAPI().deleteProcessInstance(instanceUUID);
    getManagementAPI().deletePackage(packageUUID);
  }

  public void testImplNoManuSplit() throws BonitaException {
    URL xpdlUrl = this.getClass().getResource("implNoManuSplit.xpdl");
    String processId = "implNoManuSplit";
    ProcessDefinition process = getManagementAPI().deployBar(getBarContent(xpdlUrl)).get(processId);
    PackageDefinitionUUID packageUUID = process.getPackageDefinitionUUID();
    ProcessDefinitionUUID processUUID = process.getUUID();
    ProcessInstanceUUID instanceUUID = getRuntimeAPI().instantiateProcess(processUUID);

    checkStopped(instanceUUID, new String[]{});
    // start & terminate "act1" task
    executeTask(instanceUUID, "act1");
    checkExecutedOnce(instanceUUID, new String[]{"act1"});
    getManagementAPI().undeploy(packageUUID);
    getRuntimeAPI().deleteProcessInstance(instanceUUID);
    getManagementAPI().deletePackage(packageUUID);
  }

  public void testImplNoManuJoin() throws BonitaException {
    URL xpdlUrl = this.getClass().getResource("implNoManuJoin.xpdl");
    String processId = "implNoManuJoin";
    ProcessDefinition process = getManagementAPI().deployBar(getBarContent(xpdlUrl)).get(processId);
    PackageDefinitionUUID packageUUID = process.getPackageDefinitionUUID();
    ProcessDefinitionUUID processUUID = process.getUUID();
    ProcessInstanceUUID instanceUUID = getRuntimeAPI().instantiateProcess(processUUID);

    checkStopped(instanceUUID, new String[]{});
    // start & terminate "act1" task
    executeTask(instanceUUID, "act1");
    checkExecutedOnce(instanceUUID, new String[]{"act1"});
    getManagementAPI().undeploy(packageUUID);
    getRuntimeAPI().deleteProcessInstance(instanceUUID);
    getManagementAPI().deletePackage(packageUUID);
  }
}
