package org.ow2.bonita.activity.route;

import java.net.URL;

import org.ow2.bonita.APITestCase;
import org.ow2.bonita.facade.exception.DeploymentException;
import org.ow2.bonita.util.BonitaException;

public class InitialEndingNodeTest extends APITestCase {

  public void testNoStartNode() throws BonitaException {
    URL xpdlUrl = this.getClass().getResource("noStartNode.xpdl");
    try {
      getManagementAPI().deployBar(getBarContent(xpdlUrl));
      fail("expected exception");
    } catch (DeploymentException e) {
      assertTrue(e.getMessage().contains("no initial node"));
    }
  }

  public void testNoEndingNode() throws BonitaException {
    URL xpdlUrl = this.getClass().getResource("noEndingNode.xpdl");
    try {
      getManagementAPI().deployBar(getBarContent(xpdlUrl));
      fail("expected exception");
    } catch (DeploymentException e) {
      assertTrue(e.getMessage().contains("no ending node"));
    }
  }

  public void testNoInitialAndEndingNode() throws BonitaException {
    URL xpdlUrl = this.getClass().getResource("noInitialAndEndingNode.xpdl");
    try {
      getManagementAPI().deployBar(getBarContent(xpdlUrl));
      fail("expected exception");
    } catch (DeploymentException e) {
      assertTrue(e.getMessage().contains("no initial and no ending node"));
    }
  }
}
