package org.ow2.bonita.activity.route;

import java.net.URL;

import org.ow2.bonita.APITestCase;
import org.ow2.bonita.facade.def.majorElement.ProcessDefinition;
import org.ow2.bonita.facade.uuid.PackageDefinitionUUID;
import org.ow2.bonita.facade.uuid.ProcessDefinitionUUID;
import org.ow2.bonita.facade.uuid.ProcessInstanceUUID;
import org.ow2.bonita.util.BonitaException;

public class SplitAndTest extends APITestCase {

  public void testSplitAnd1Tr() throws BonitaException {
    URL xpdlUrl = this.getClass().getResource("splitAnd1Tr.xpdl");
    String processId = "splitAnd1Tr";
    ProcessDefinition process = getManagementAPI().deployBar(getBarContent(xpdlUrl)).get(processId);
    PackageDefinitionUUID packageUUID = process.getPackageDefinitionUUID();
    ProcessDefinitionUUID processUUID = process.getUUID();
    ProcessInstanceUUID instanceUUID = getRuntimeAPI().instantiateProcess(processUUID);
    checkExecutedOnce(instanceUUID, new String[]{"r1"});
    getManagementAPI().undeploy(packageUUID);
    getRuntimeAPI().deleteProcessInstance(instanceUUID);
    getManagementAPI().deletePackage(packageUUID);
  }

  public void testSplitAnd2Tr() throws BonitaException {
    URL xpdlUrl = this.getClass().getResource("splitAnd2Tr.xpdl");
    String processId = "splitAnd2Tr";
    ProcessDefinition process = getManagementAPI().deployBar(getBarContent(xpdlUrl)).get(processId);
    PackageDefinitionUUID packageUUID = process.getPackageDefinitionUUID();
    ProcessDefinitionUUID processUUID = process.getUUID();
    ProcessInstanceUUID instanceUUID = getRuntimeAPI().instantiateProcess(processUUID);
    checkExecutedOnce(instanceUUID, new String[]{"r1"});
    checkOnlyOneExecuted(instanceUUID, new String[]{"r2","r3"});
    getManagementAPI().undeploy(packageUUID);
    getRuntimeAPI().deleteProcessInstance(instanceUUID);
    getManagementAPI().deletePackage(packageUUID);

  }

  public void testSplitAndProed2Tr() throws BonitaException {
    URL xpdlUrl = this.getClass().getResource("splitAndProed2Tr.xpdl");
    String processId = "splitAndProed2Tr";
    ProcessDefinition process = getManagementAPI().deployBar(getBarContent(xpdlUrl)).get(processId);
    PackageDefinitionUUID packageUUID = process.getPackageDefinitionUUID();
    ProcessDefinitionUUID processUUID = process.getUUID();
    ProcessInstanceUUID instanceUUID = getRuntimeAPI().instantiateProcess(processUUID);
    checkExecutedOnce(instanceUUID, new String[]{"r1"});
    checkOnlyOneExecuted(instanceUUID, new String[]{"r2","r3"});
    getManagementAPI().undeploy(packageUUID);
    getRuntimeAPI().deleteProcessInstance(instanceUUID);
    getManagementAPI().deletePackage(packageUUID);
  }
}
