package org.ow2.bonita.env;

import junit.framework.TestCase;

import org.ow2.bonita.env.generator.DbHistoryEnvGenerator;
import org.ow2.bonita.env.generator.EnvGenerator;

public class XpdlEnvironmentParserTest extends TestCase {

  public void testParseEnvironmentFactoryFromXmlStringBadEnvironment() {
    final EnvGenerator envGenerator = new DbHistoryEnvGenerator();
    envGenerator.setBlockEntry("session", "test session", "<hibernate-session-test name='default-session' />"
        + "<hibernate-session name='test-session' />", true);
    try {
      XpdlEnvironmentParser.parseEnvironmentFactoryFromXmlString(envGenerator.createEnvironmentXml());
      fail("Invalid environment");
    } catch (final InvalidEnvironmentException e) {
      //ok
    }
  }

  public void testParseEnvironmentFactoryFromXmlStringGoodEnvironment() {
    final EnvGenerator envGenerator = new DbHistoryEnvGenerator();
    envGenerator.setBlockEntry("session", "test session", "<hibernate-session name='default-session' />"
        + "<hibernate-session name='test-session' />", true);
    XpdlEnvironmentParser.parseEnvironmentFactoryFromXmlString(envGenerator.createEnvironmentXml());
  }
}
