package org.ow2.bonita.example;

import java.net.URL;
import java.util.HashMap;
import java.util.Map;

import org.ow2.bonita.APITestCase;
import org.ow2.bonita.example.aw.MultiInstantiationApproval;
import org.ow2.bonita.example.aw.hook.Accept;
import org.ow2.bonita.example.aw.hook.CheckDecision;
import org.ow2.bonita.example.aw.hook.Reject;
import org.ow2.bonita.example.aw.instantiator.ApprovalInstantiator;
import org.ow2.bonita.example.aw.performer.UserPerformerAssign;
import org.ow2.bonita.facade.def.majorElement.ProcessDefinition.ProcessState;
import org.ow2.bonita.facade.uuid.ProcessInstanceUUID;



public class AWMultiInstTest extends APITestCase {
  
  public void testAWMultiInstReject0() throws Exception {
    execute(0, "Reject");
  }
  
  public void testAWMultiInstReject1() throws Exception {
    execute(1, "Reject");
  }
  public void testAWMultiInstAccept2() throws Exception {
    execute(2, "Accept");
  }
  public void testAWMultiInstAccept3() throws Exception {
    execute(3, "Accept");
  }
  
  protected void execute(int numberOfAccept, String nodeToCheck) throws Exception {
    URL xpdlUrl = MultiInstantiationApproval.class.getResource("MultiInstantiation.xpdl");
    byte[] barFile = getBarContent(xpdlUrl, UserPerformerAssign.class, 
        Accept.class, Reject.class, CheckDecision.class, ApprovalInstantiator.class); 

    Map<String, String> logins = new HashMap<String, String>();
    logins.put("john", "bpm");
    logins.put("jack", "bpm");
    logins.put("james", "bpm");
    
    ProcessInstanceUUID instanceUUID = MultiInstantiationApproval.execute(barFile, numberOfAccept, logins, loginContext);

    login();
    checkExecutedOnce(instanceUUID, new String[]{nodeToCheck});
    MultiInstantiationApproval.cleanPackage(instanceUUID);
    assertEquals(0, getQueryDefinitionAPI().getProcesses(MultiInstantiationApproval.PROCESS_ID, ProcessState.DEPLOYED).size());
  }
  protected String getLogin() {
    return "john";
  }
  protected String getPassword() {
    return "bpm";
  }
}
