/**
 * Copyright (C) 2007 Bull S. A. S. Bull, Rue Jean Jaures, B.P.68, 78340, Les
 * Clayes-sous-Bois This library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation version 2.1 of the License. This
 * library is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
 * A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details. You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301,
 * USA.
 */
package org.ow2.bonita.example;

import java.net.URL;

import org.ow2.bonita.APITestCase;
import org.ow2.bonita.example.aw.ApprovalWorkflow;
import org.ow2.bonita.example.aw.hook.Accept;
import org.ow2.bonita.example.aw.hook.Reject;
import org.ow2.bonita.example.aw.mapper.ApprovalMapper;
import org.ow2.bonita.facade.def.majorElement.ProcessDefinition.ProcessState;
import org.ow2.bonita.facade.uuid.ProcessInstanceUUID;
import org.ow2.bonita.util.BonitaException;

/**
 * Testing ApprovalWorkflow example
 */
public class AWTest extends APITestCase {

  public void testAW1() throws BonitaException {
    execute();
  }

  public void testAW2() throws BonitaException {
    execute();
  }

  public void testAWTwice() throws BonitaException {
    execute();
    execute();
  }

  protected void execute() throws BonitaException {
    URL xpdlUrl = ApprovalWorkflow.class.getResource("ApprovalWorkflow.xpdl");
    byte[] barFile = getBarContent(xpdlUrl, ApprovalMapper.class, Accept.class, Reject.class);
    ProcessInstanceUUID instanceUUID = ApprovalWorkflow.execute(barFile, true);
    ApprovalWorkflow.cleanPackage(instanceUUID);
    
    assertEquals(0, getQueryDefinitionAPI().getProcesses(ApprovalWorkflow.PROCESS_ID, ProcessState.DEPLOYED).size());  
  }
  protected String getLogin() {
    return "john";
  }
  protected String getPassword() {
    return "bpm";
  }
}
