package org.ow2.bonita.facade.imposterizer;

import java.lang.reflect.Proxy;

import org.jmock.api.Invokable;
import org.jmock.lib.JavaReflectionImposteriser;

public class CustomImposterizer extends JavaReflectionImposteriser {

  private Class< ? >[] classesToImpost;
  
  @SuppressWarnings("unchecked")
  public <T> T imposterise(final Invokable mockObject, Class<T> mockedType, Class< ? >... ancilliaryTypes) {
    if (ImpostInterceptor.isAnImpostClass(classesToImpost, mockedType)) {
      
      Class< ? >[] proxiedClasses = new Class< ? >[ancilliaryTypes.length + 1];
      proxiedClasses[0] = mockedType;
      System.arraycopy(ancilliaryTypes, 0, proxiedClasses, 1, ancilliaryTypes.length);
      
      final ClassLoader classLoader = CustomImposterizer.class.getClassLoader();
      ImpostInterceptor interceptor = new ImpostInterceptor();
      interceptor.setMockObject(mockObject);
      interceptor.setType(mockedType);
      interceptor.setClassesToImpost(classesToImpost);
      
      return (T)Proxy.newProxyInstance(classLoader, proxiedClasses, interceptor);
    }
    return super.imposterise(mockObject, mockedType, ancilliaryTypes);
  }

  public void setClassesToImpost(Class< ? >[] classes) {
    this.classesToImpost = classes;
  }
}
