package org.ow2.bonita.mail;
import java.util.Properties;

import org.ow2.bonita.facade.QueryAPIAccessor;
import org.ow2.bonita.facade.runtime.ActivityBody;
import org.ow2.bonita.facade.runtime.ActivityInstance;


public class MyEmailHook extends EmailHook {

  public Properties getEmailProperties(QueryAPIAccessor accessor,
      ActivityInstance<ActivityBody> activityInstance) throws Exception {
    Properties properties = System.getProperties();
    String subject = "";
    String mailServer = "";
    String to = "";
    String from = "";
    String body = "";
    if ((String)accessor.getQueryRuntimeAPI().getVariable(activityInstance.getUUID(), "subject") != null) {
      subject = (String)accessor.getQueryRuntimeAPI().getVariable(activityInstance.getUUID(), "subject");
    }
    if ((String)accessor.getQueryRuntimeAPI().getVariable(activityInstance.getUUID(), "mailServer") != null) {
      mailServer = (String)accessor.getQueryRuntimeAPI().getVariable(activityInstance.getUUID(), "mailServer");
    }
    //Warning: only one recipient is expected!
    if (accessor.getQueryRuntimeAPI().getVariable(activityInstance.getUUID(), "to") != null) {
      if (accessor.getQueryRuntimeAPI().getVariable(activityInstance.getUUID(), "to") instanceof String) {
        to = (String)accessor.getQueryRuntimeAPI().getVariable(activityInstance.getUUID(), "to");
      }
    }
    if ((String)accessor.getQueryRuntimeAPI().getVariable(activityInstance.getUUID(), "from") != null) {
      from = (String)accessor.getQueryRuntimeAPI().getVariable(activityInstance.getUUID(), "from");
    }
    if ((String)accessor.getQueryRuntimeAPI().getVariable(activityInstance.getUUID(), "body") != null) {
      body = (String)accessor.getQueryRuntimeAPI().getVariable(activityInstance.getUUID(), "body");
    }
    properties.setProperty("mail.subject", subject);
    properties.setProperty("mail.smtp.host", mailServer);
    properties.setProperty("mail.to", to);
    properties.setProperty("mail.from", from);
    properties.setProperty("mail.body", body);
    return properties;
  }
}
